#!/usr/bin/perl
#   hhc2bookmark.pl
#   convert contents file in chm to bookmark
#
#   Copyright (c) 2003 by Samuel Yang <labourvanity@yahoo.com.tw>
#
#   This program is free software;
#   You can redistribute it and/or modify it under the terms of
#   the GNU Lesser General Public License (version 2) as published by
#   the Free Software Foundation.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this package; if not, contact to me.
#
#  version 0.1a

$,=" ";
$\="\n";

eval '$'.$1.'=$2;' while $ARGV[0] =~ /^--(root|lo)=(.*)/ && shift;

$obj="<object [^>]*>";
$param="<param [^>]*>";
@quote=( '([^ \'"]+)[ >]', "('[^']+')", '("[^"]+")' );
$typereg=" type=($quote[0]|$quote[1]|$quote[2])";
$namereg=" name=($quote[0]|$quote[1]|$quote[2])";
$valuereg=" value=($quote[0]|$quote[1]|$quote[2])";

print '<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=UTF-8">';
print "<TITLE>Bookmarks</TITLE>\n<H1>Bookmarks</H1>";

$mark="";
$post="";

GLOBAL: while(<>){
    chomp;
    if( /(.*)($obj)(.*)/i ){
	$_=$post.$1;
	$object=$2;
	$post=$3;
    }else{
	$_=$post.$_;
	$object="";
	$post="";
    }
    while( s/(<ul>)|(<\/ul>)|(<li>)//i ){
	$folder=$1.$2;
	$item=$3;
	$folder =~ s/ul>/DL><p>\n    /i;
	$item =~ s/li/DT/i;
	$mark=$mark.$folder.$item;
    }
    $_=$object;
    next GLOBAL unless /$typereg/i;
    $type=$4;
    next GLOBAL unless $type =~ /text\/sitemap/i;
    $name="";
    $local="";
    OBJECT: while(<>){
	if( /($param)/i ){
	    $_=$1;
	    next OBJECT unless /$valuereg/i;
	    $value=$4;
	    next OBJECT unless /$namereg/i;
	    $_= lc $4;
	    s/(^["'])|(["']$)//g;
	    $value= lc $value if $lo =~ /on/i;
	    eval '$'.$_."=".$value if /(local)|(name)/;
	    next OBJECT;
	}
	next OBJECT unless /<\/object>/i;
	last OBJECT if $name =~ /^$/;
	last OBJECT if $local =~ /^$/ && print "$mark<H3>$name</H3>";
	print $mark.'<A HREF="file://'.$root."/".$local.'">'.$name.'</A>';
	last OBJECT;
    }
    $mark="";
    $post="";
}
